package com.izouma.awesomeadmin.web;

import java.util.*;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.Feedback;
import com.izouma.awesomeadmin.service.FeedbackService;

/**
*  controller类
*/
@Controller
@RequestMapping("/feedback")
public class FeedbackController extends BaseController{

    @Autowired
    private FeedbackService feedbackService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(Feedback record) {
        List<Feedback> pp = feedbackService.getFeedbackList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getFeedback", method = RequestMethod.GET)
    @ResponseBody
    public Result getFeedback(@RequestParam(required = false, value = "id") String id) {
        Feedback data = feedbackService.getFeedbackById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(Feedback record) {
        Feedback data = feedbackService.getFeedback(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, Feedback record) {
        Map<String, Object> result = new HashMap<>();

        List<Feedback> pp =feedbackService.getFeedbackByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(Feedback record) {
        boolean num = feedbackService.createFeedback(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateFeedback(Feedback record) {
        boolean num = feedbackService.updateFeedback(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteFeedback(@RequestParam(required = true, value = "id") String id) {

        boolean num = feedbackService.deleteFeedback(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }
}

